﻿#pragma once
#include <string>
#include <boost/flyweight.hpp>
#include <boost/flyweight/key_value.hpp>
#include <boost/flyweight/no_tracking.hpp>

enum class font_style {
	regular = 1 << 1, // 正常
	light   = 1 << 2, // 轻体
	thin    = 1 << 3, // 细体
	medium  = 1 << 4, // 中等
	bold    = 1 << 5, // 粗体

	italic  = 1 << 11, // 斜体
	bold_italic = bold | italic, // 粗斜体
	thin_italic = thin | italic, // 细斜体
	light_italic = light | italic, // 轻斜体
	medium_italic = medium | italic, // 中等斜体
};

using font_family = boost::flyweight<
	std::string,
	boost::flyweights::no_tracking
>;

using font_path = boost::flyweight<
	std::string,
	boost::flyweights::no_tracking
>;
