﻿#pragma once
#include <vulkan/vulkan.hpp>
#include <filesystem>

class renderer_shader {
public:
	~renderer_shader();

	bool load(const std::filesystem::path& in_file_path, vk::Device in_device);

	[[nodiscard]] const auto& get_shader_module() const {
		return shader_module;
	}

	[[nodiscard]] const auto& get_device() const {
		return device;
	}

	[[nodiscard]] bool is_valid() const {
		return shader_module;
	}
private:
	void destroy();
	bool create_shader_module(const std::vector<uint8_t>& in_code);

	vk::ShaderModule shader_module;
	vk::Device device;
	std::filesystem::path file_path;
};
