﻿#include "renderer_text.h"

#include <spdlog/spdlog.h>

// 在SDFFontCache.cpp中添加实现
const std::u32string aorii_font_manager::COMMON_ASCII =
    U"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";

const std::u32string aorii_font_manager::COMMON_CHINESE =
    U"的一是在不了有和人这中大为上个国我以要他时来用们生到作地于出就分对成会可主发年动同工也能下过子说产种面而方后多定行学法所民得经十三之进着等部度家电力里如水化高自二理起小物现实加量都两体制机当使点从业本去把性好应开它合还因由其些然前外天政四日那社义事平形相全表间样与关各重新线内数正心反你明看原又么利比或但质气第向道命此变条只没结解问意建月公无系军很情者最立代想已通并提直题党程展五果料象员革位入常文总次品式活设及管特件长求老头基资边流路级少图山统接知较将组见计别她手角期根论运农指几九区强放决西被干做必战先回则任取据处队南给色光门即保治北造百规热领七海口东导器压志世金增争济阶油思术极交受联什认六共权收证改清己美再采转更单风切打白教速花带安场身车例真务具万每目至达走积示议声报斗完类八离华名确才科张信马节话米整空元况今集温传土许步群广石记需段研界拉林律叫且究观越织装影算低持音众书布复容儿须际商非验连断深难近矿千周委素技备半办青省列习响约支般史感劳便团往酸历市克何除消构府称太准精值号率族维划选标写存候毛亲快效斯院查江型眼王按格养易置派层片始却专状育厂京识适属圆包火住调满县局照参红细引听该铁价严";

const std::u32string aorii_font_manager::COMMON_PUNCTUATION =
    U"，。！？：；''""《》【】（）、";

const std::u32string aorii_font_manager::COMMON_NUMBERS =
    U"0123456789";

aorii_font_manager* s_font_manager = nullptr;

aorii_font_manager::aorii_font_manager() {
}

aorii_font_manager::~aorii_font_manager() {
    FT_Done_FreeType(library);
}

bool aorii_font_manager::init() {
    const FT_Error error = FT_Init_FreeType(&library);
    if (error) {
        spdlog::error("初始化FreeType失败: {}", FT_Error_String(error));
        return false;
    }
    return true;
}

bool aorii::create_font_manager() {
    s_font_manager = new aorii_font_manager();
    if (!s_font_manager->init()) {
        delete s_font_manager;
        s_font_manager = nullptr;
        spdlog::error("初始化文本系统失败");
        return false;
    }
    return true;
}

void aorii::destroy_font_manager() {
    delete s_font_manager;
    s_font_manager = nullptr;
}

aorii_font_manager* aorii::get_font_manager() {
    return s_font_manager;
}
