﻿#pragma once
#include "misc/mapped_file.h"
#include <freetype/freetype.h>

class aorii_font_manager {
public:
    aorii_font_manager();
    ~aorii_font_manager();

    bool init();

    // 预缓存一组字符
    bool precache_characters(const std::u32string &characters) {
        return false;
    }

    // 预缓存常用字符集
    void precache_common_characters() {
        precache_characters(COMMON_ASCII);
        precache_characters(COMMON_PUNCTUATION);
        precache_characters(COMMON_NUMBERS);
        precache_characters(COMMON_CHINESE);
    }
private:
    FT_Library library;

    // 常用字符集定义
    static const std::u32string COMMON_ASCII; // ASCII字符
    static const std::u32string COMMON_PUNCTUATION; // 常用标点符号
    static const std::u32string COMMON_NUMBERS; // 数字
    static const std::u32string COMMON_CHINESE; // 常用汉字
};

namespace aorii {
    bool create_font_manager();
    void destroy_font_manager();
    aorii_font_manager* get_font_manager();
}
